<?php
//
//
//-------------------------------------------------------
//-- HANGMANLite                                       --
//-- PHP game by Giovanni Crisci                       --
//-- http://giovi.supereva.it                          --
//-- Images taken from ASP code written by             --
//-- ASP101 http://www.asp101.com                      --
//-- Requires PEAR installed                           --
//-- http://pear.php.net                               --
//-------------------------------------------------------
//
// main file
//

require_once ('config.php');

// functions and variables
$alfabeto = array ('A' => 'a','B' => 'b','C' => 'c','D' => 'd','E' => 'e',
 'F' => 'f','G' => 'g','H' => 'h','I' => 'i','J' => 'j','K' => 'k','L' => 'l',
 'M' => 'm','N' => 'n','O' => 'o','P' => 'p','Q' => 'q','R' => 'r','S' => 's',
 'T' => 't','U' => 'u','V' => 'v','W' => 'w','X' => 'x','Y' => 'y','Z' => 'z');
session_start ();

// choose a random word from the database

function ScegliParola ($dbase, $dtable) {
 require_once ('DB.php');
 $dsn = "sqlite:///$dbase";
 $db = DB::connect($dsn, true);
 if (DB::isError($db))
  die ($db->getMessage());
 $res = $db->query('select max(id) from '.$dtable);
 if (DB::isError($res))
  die ($res->getMessage());
 $numero_parole = $res->fetchRow();
 $posizione_parola = rand (2, $numero_parole[0]);
 $res = $db->query('select id, word from '.$dtable.' where id = '.$posizione_parola);
 $parola = $res->fetchRow();
 $db->disconnect();
 return ($parola);
}

// check if the player can be added to the top list

function ControllaRecord ($dbase, $dtable, $wordid, $tempo, $tentativi) {
 $chk = array(false);
 require_once ('DB.php');
 $dsn = "sqlite:///$dbase";
 $db = DB::connect($dsn, true);
 if (DB::isError($db))
  die ($db->getMessage());
 $res = $db->query('select * from '.$dtable.' where id = '.$wordid);
 if (DB::isError($res))
  die ($res->getMessage());
 $riga = $res->fetchRow();
 if ($tentativi<$riga[3] or ($tentativi==$riga[3] and $tempo<$riga[4]))
  $chk[0] = true;
 if ($riga[3]==6) $riga[2]='*nuovo**';
 $chk[1] = $riga[2];
 $chk[2] = $riga[3];
 $chk[3] = $riga[4];
 return $chk;
}

// read the actual best score

function CercaRecord ($dbase, $dtable, $wordid) {
 require_once ('DB.php');
 $dsn = "sqlite:///$dbase";
 $db = DB::connect($dsn, true);
 if (DB::isError($db))
  die ($db->getMessage());
 $res = $db->query('select best, errors, time from '.$dtable.' where id = '.$wordid);
 if (DB::isError($res))
  die ($res->getMessage());
 $riga = $res->fetchRow();
 return $riga;
}

// changes all the unguessed letters with _

function CalcolaIndovinata ($parola, $escludi, $alfabeto) {
 $alfabeto = array_flip ($alfabeto);
 $escluse = strtr ($escludi, $alfabeto);
 $escluse = '['.$escluse.']';
 $escluse = ereg_replace ($escluse, '', '[ABCDEFGHIJKLMNOPQRSTUVWXYZ]');
 $indovinata = ereg_replace ($escluse, '_', $parola);
 return $indovinata;
}

// seeks the chosen letter in the word

function TrovaLettera ($lettera, $parola, $scelte, $alfabeto) {
 $alfabeto = array_flip ($alfabeto);
 $lettera = substr ($lettera, 0, 1);
 $lettera = strtr ($lettera, $alfabeto);
 $scelte.= $lettera;
 if (ereg ($lettera, $parola)) {
  $controllo = true;
 }
 else {
  $controllo = false;
 }
 $risposta = array ($scelte, $controllo);
 return $risposta;
}

// and this is the programme!

// the word to be guessed has already been chosen

if (isset($_GET['letter']) and isset($_SESSION['gchangman'])) {
 $variab = explode ('/', $_SESSION['gchangman']);
 $indovina = $variab[0];
 $scelte = $variab[1];
 $tentativi = $variab[2];
 $checklet = TrovaLettera ($_GET['letter'], $indovina, $scelte, $alfabeto);
 $scelte = $checklet[0];
 if (!$checklet[1]) {
  $tentativi = $tentativi +1;
 }
 $indovinata = CalcolaIndovinata ($indovina, $scelte, $alfabeto);
}
else {

// reset everything and choose a new word

 $tentativi=0;
 $scelte = ('_');
 $parola = array (0, '');
 while ($parola[1]=='')
  $parola = ScegliParola ($dbase, $dtable);
 $indovina = $parola[1];
 $_SESSION['gcid'] = $parola[0];
 $indovinata = CalcolaIndovinata ($indovina, $scelte, $alfabeto);
 $_SESSION['gctempo'] = time();
}

// set the cookie (or the get variable) via PHP sessions

$_SESSION['gchangman'] = ($indovina.'/'.$scelte.'/'.$tentativi);

if ($tentativi>6) $tentativi=6;

// load the first part of the template

$pagina = file($template);
$totrighe = count($pagina);
$i = 0;
while (rtrim($pagina[$i])!="<!--HANGMAN-->") {
 print $pagina[$i];
 $i++;
}

// print the word hiding the unfound letters

print ('<p><img src="images/hang_'.($tentativi+1).'.gif" style="border:0;width:100px;height:100px" alt="Miss '.$tentativi.'/6" /></p>');
echo ("\n<p>\n");
$caratteri = preg_split('//', $indovinata, -1, PREG_SPLIT_NO_EMPTY);
foreach ($caratteri as $lettalf) {
 $lettalf = strtr ($lettalf, $alfabeto);
 if ($lettalf==' ') {
  print (' <img src="images/lb_~.gif" style="border:0;width:20px;height:20px" alt="" />');
 }
 else {
  print (' <img src="images/lb_'.$lettalf.'.gif" style="border:0;width:20px;height:20px" alt="'.$lettalf.'" />');
 }
 echo ("\n");
 print (' <img src="images/lb_~.gif" style="border:0;width:20px;height:20px" alt="" />');
 echo ("\n");
}
print ('</p>');

// last part

if ($indovina!=$indovinata) {
 if ($tentativi>=6) {
  
// ahi! hanged!

  print ('<p>'.HANGED);
  if ($showsol) print(' '.WORDWAS.' '.$indovina);
  $bestnow = CercaRecord ($dbase, $dtable, $_SESSION['gcid']);
  if ($bestnow[1]==6)
   print ('<br />'.NONE.'</p>');
   else {
   if ($bestnow[0]=='') $bestnow[0]=ANON;
   print ('<br />'.$bestnow[0].' '.GUESSEDIT.' '.$bestnow[2].' '.SECONDS.' '.$bestnow[1].' '.CHANCES.'.</p>');
  } 
 }
 else {

// shows the full alphabet from which the letters can be chosen

  $scelt = preg_split('//', $scelte, -1, PREG_SPLIT_NO_EMPTY);
  echo ("\n<p>\n");
  foreach ($alfabeto as $lettalf) {
   $contrl = false;
   foreach ($scelt as $lett) {
    if (!strcasecmp ($lettalf, $lett)) {
     $contrl = true;
    }
   }
   if ($contrl) {
    print (' <img src="images/lr_'.$lettalf.'.gif" style="border:0;width:20px;height:20px" alt="'.$lettalf.'" />');
   }
   else {
    print (' <a href="'.$_SERVER['PHP_SELF'].'?letter='.$lettalf.'"><img src="images/lb_'.$lettalf.'.gif" style="border:0;width:20px;height:20px" alt="'.$lettalf.'" /></a>');
   }
   if ($lettalf=='m') echo ("\n <br />");
   echo ("\n");
  }
  echo ("</p>\n"); 
 }
}
else {

// the word has been guessed!

 echo ("\n<p>\n");
 print (CONGRAT);
 $tempo = time() - $_SESSION['gctempo'];
 $oldbest = ControllaRecord ($dbase, $dtable, $_SESSION['gcid'], $tempo, $tentativi);
 if ($oldbest[1]=='') $oldbest[1]=ANON2;
 if ($oldbest[0]) {

// and there's a new record

  print ('<br />'.GUESST);
  if ($oldbest[1]!='*nuovo**') print (' '.BEAT.' '.$oldbest[1]);
  require_once ('DB.php');
  $dsn = "sqlite:///$dbase";
  $db = DB::connect($dsn, true);
  if (DB::isError($db))
   die ($db->getMessage());
  $res = $db->query('update '.$dtable.
   ' set errors = '.$tentativi.', time = '.$tempo.
   ' where id = '.$_SESSION['gcid']);
  if (DB::isError($res))
   die ($res->getMessage());
  $db->disconnect();

// here is the form to insert own name

  ?>
</p>
<form method="post" action="insbest.php">
 <input type="hidden" name="wordid" value="<?=$_SESSION['gcid']; ?>" />
 <input type="hidden" name="besttime" value="<?=$tempo; ?>" />
 <input type="hidden" name="besttent" value="<?=$tentativi; ?>" />
 <p><?=INSRT; ?><input type="text" name="newbest" size="15" maxlength="15" />
 <input type="submit" value="<?=SBMT; ?>" name="go" /></p>
</form>
  <?php
 }

// word guessed, but someone did better

 else print('<br />'.SOMEBUT.' '.$oldbest[1].' '.GUESSEDIT.' '.$oldbest[3].' '.SECONDS.' '.$oldbest[2].' '.CHANCES.'.</p>');
}

// show the final part of the template

print ('<p><a href="'.$_SERVER['PHP_SELF'].'">'.NWGAME.'</a></p>');
$i++;
while ($i<$totrighe) {
 print $pagina[$i];
 $i++;
}

?>